// BasIS version 1.00

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#define XX 200

#define RE 0.005

int main(void){
  FILE *out;
  int *iPermutation /*, iInvpermutation[2 * XX + 2],iTempperm[2 * XX + 2]*/;
  double **eStatistics;
  double eNewtrajectory();
  double eTemp;
  double eSumofweights1, eSumofweightssquared1;
  double eSumofweights2, eSumofweightssquared2;
  double *eSumofweightInversion, *eSumofweightTransposition;
  int *iNumberofproposalsInversion, *iNumberofproposalsTransposition;
  double eFirstweight;
  int iIntrand();
  void Swap();
  void Reversion(), Transposition(), Invtransposition1(), Invtransposition2();
  int iI, iJ, iN, iM;
  long int iIteration;
  int iXX;
  FILE *fInp1, *fInp2;
  int iDirection1[100],iDirection2[100],iNumberofgenes1,iNumberofgenes2;
  int iTempperm[100];
  char cName1[100][10],cName2[100][10],cTemp;
  int iTest();

  out=fopen("out.txt","w");
#ifdef _PLAN9
  srand(154);
#else
  srandom(154);
#endif

  /*Reading the genomes*/
  fInp1 = fopen("3mitochondria.txt","r");
  fInp2 = fopen("2mitochondria.txt","r");
  while((cTemp = getc(fInp1)) != '\n');
  cTemp = getc(fInp1);
  iNumberofgenes1 = 0;
  while(cTemp == '+' || cTemp == '-'){
    if(cTemp == '+'){
      iDirection1[iNumberofgenes1] = 1;
    }
    else{
      iDirection1[iNumberofgenes1] = -1;
    }
    iI = 0;
    while((cName1[iNumberofgenes1][iI] = getc(fInp1)) != '\n'){
      iI++;
    }
    cName1[iNumberofgenes1][iI] = '\0';
    cTemp = getc(fInp1);
    iNumberofgenes1++;
  }

  while((cTemp = getc(fInp2)) != '\n');
  cTemp = getc(fInp2);
  iNumberofgenes2 = 0;
  while(cTemp == '+' || cTemp == '-'){
    if(cTemp == '+'){
      iDirection2[iNumberofgenes2] = 1;
    }
    else{
      iDirection2[iNumberofgenes2] = -1;
    }
    iI = 0;
    while((cName2[iNumberofgenes2][iI] = getc(fInp2)) != '\n'){
      iI++;
    }
    cName2[iNumberofgenes2][iI] = '\0';
    cTemp = getc(fInp2);
    iNumberofgenes2++;
  }

  fclose(fInp1);
  fclose(fInp2);

  /* creating the permutation */
  /* finding the common genes, row 'permutatrion'*/

  for(iI = 0; iI < iNumberofgenes2; iI++){
    iTempperm[iI] = -1000;
  }

  for(iI = 0; iI < iNumberofgenes1; iI++){
    iJ = 0;
    while(iTest(cName1[iI],cName2[iJ]) == 0 && iJ < iNumberofgenes2){
      iJ++;
    } 
    if(iJ < iNumberofgenes2){
      if(iDirection1[iI] == iDirection2[iJ]){
	iTempperm[iJ] = iI + 1;
      }
      else{
	iTempperm[iJ] = -iI - 1;
      }
    }
  }

  /* cutting out -1000's*/

  for(iI = 0; iI < iNumberofgenes2; iI++){
    if(iTempperm[iI] == -1000){
      iNumberofgenes2--;
      for(iJ = iI; iJ < iNumberofgenes2; iJ++){
	iTempperm[iJ] = iTempperm[iJ + 1];
      }
      iI--;
    }
  }

  /* transforming it into nonsigned permutation*/

  iXX = iNumberofgenes2;
  iPermutation = (int*) malloc(sizeof(int)*(2 * iXX + 2));

  iPermutation[0] = 0;
  iPermutation[2 * iXX + 1] = 2 * iXX + 1;
  for(iI = 0; iI < iNumberofgenes2; iI++){
    if(iTempperm[iI] > 0){
      iPermutation[2 * iI + 1] = 2 * iTempperm[iI] - 1;
      iPermutation[2 * iI + 2] = 2 * iTempperm[iI];
    }
    else{
      iPermutation[2 * iI + 1] = -2 * iTempperm[iI];
      iPermutation[2 * iI + 2] = -2 * iTempperm[iI] - 1;      
    }
  }

  for(iI = 0; iI < 2 * iXX + 2; iI++){
    printf("%d ",iPermutation[iI]);
  }
  printf("\n");

  /* allocating memory */

  eStatistics = (double**) malloc(sizeof(double*)*(2 * iXX));
  for(iI = 0; iI < 2 * iXX; iI++){
    eStatistics[iI] = (double*) malloc(sizeof(double)*(2 * iXX));
  }
  eSumofweightInversion = (double*) malloc(sizeof(double)*(2 * iXX));
  eSumofweightTransposition = (double*) malloc(sizeof(double)*(2 * iXX));
  iNumberofproposalsInversion = (int*) malloc(sizeof(int)*(2 * iXX));
  iNumberofproposalsTransposition = (int*) malloc(sizeof(int)*(2 * iXX));

  /* Bayesian importance sampler part */

//++pac
#ifdef _PLAN9
  srand(1025);
#else
  srandom(1025);
#endif

  /* set the statistics to 0 */

  for(iI = 0; iI < 2 * iXX; iI++){
    for(iJ = 0; iJ < 2 * iXX; iJ ++){
      eStatistics[iI][iJ] = 0.0;
    }
  }

  for(iI = 0; iI < 2 * iXX; iI++){
    eSumofweightInversion[iI] = 0.0; 
    eSumofweightTransposition[iI] = 0.0;
    iNumberofproposalsInversion[iI] = 0;
    iNumberofproposalsTransposition[iI] = 0;
  }


  /* sampling */
  eSumofweights1 = 0.0; 
  eSumofweightssquared1 = 0.0; 
  eSumofweights2 = 0.0; 
  eSumofweightssquared2 = 0.0; 
  iIteration = 0;
  eFirstweight = 0.0;
  while(eFirstweight == 0.0){
    eTemp = 1.0/eNewtrajectory(iXX,iPermutation,&iN,&iM);
    if(iN >= 2 * iXX || iM >= 2 * iXX){
      printf("Too bad rearrangement!\n");
    }
    else{
      for(iI = 1; iI <= iM; iI++){
	eTemp = eTemp * 2.0 / (double)(iXX * iXX + iXX + 2.0);
      }
      eTemp = eTemp * 2.0 / (double)(iXX * iXX + iXX + 2.0);
      for(iJ = 1; iJ <= iN; iJ++){
	eTemp = eTemp * (double)iJ/(double)(iJ + iM);
	eTemp = eTemp * 2.0 / (double) (iXX * iXX * iXX - iXX + 2.0);
      }
      eTemp = eTemp * 2.0 / (double) (iXX * iXX * iXX - iXX + 2.0);
      eStatistics[iN][iM] += eTemp;
      eFirstweight = eTemp;
      eTemp = 1.0;

      eSumofweightInversion[iM] += eTemp; 
      eSumofweightTransposition[iN] += eTemp;
      iNumberofproposalsInversion[iM]++;
      iNumberofproposalsTransposition[iN]++;

      eSumofweights1 += eTemp *(double) iM ;
      eSumofweightssquared1 += eTemp * eTemp * (double) (iM * iM);
      eSumofweights2 += eTemp *(double) iN ;
      eSumofweightssquared2 += eTemp * eTemp * (double) (iN * iN);
      printf("m = %d n = %d, eSumofweightssquared1 : %e, eSumofweightssquared2 : %e\n",iM,iN,eSumofweightssquared1,eSumofweightssquared2 );
    }
  }
  while(eSumofweights1 * eSumofweights1 / eSumofweightssquared1 < 1.0/(RE * RE) || eSumofweights2 * eSumofweights2 / eSumofweightssquared2 < 1.0 / (RE * RE)){
    //printf("Iteration %ld.\n",iIteration);
    eTemp = 1.0/(eNewtrajectory(iXX,iPermutation,&iN,&iM) * eFirstweight);
    if(iN >= 2 * iXX || iM >= 2 * iXX){
      printf("Too bad rearrangement!\n");
    }
    else{
      for(iI = 1; iI <= iM; iI++){
	eTemp = eTemp * 2.0 / (double)(iXX * iXX + iXX + 2.0);
      }
      eTemp = eTemp * 2.0 / (double)(iXX * iXX + iXX + 2.0);
      for(iJ = 1; iJ <= iN; iJ++){
	eTemp = eTemp * (double)iJ/(double)(iJ + iM);
	eTemp = eTemp * 2.0 / (double) (iXX * iXX * iXX - iXX + 2.0);
      }
      eTemp = eTemp * 2.0 / (double) (iXX * iXX * iXX - iXX + 2.0);
      eStatistics[iN][iM] += eTemp;
      if(iNumberofproposalsInversion[iM] > 0){
	eSumofweights1 -= (double) iM * eSumofweightInversion[iM]; 
	eSumofweightssquared1 -= (double) iM * iM *  eSumofweightInversion[iM] *  eSumofweightInversion[iM] / (double) iNumberofproposalsInversion[iM];
      }
      if(iNumberofproposalsTransposition[iN] > 0){
	eSumofweights2 -= (double) iN * eSumofweightTransposition[iN]; 
	eSumofweightssquared2 -= (double) iN * iN *  eSumofweightTransposition[iN] *  eSumofweightTransposition[iN] / (double) iNumberofproposalsTransposition[iN];
      }
      eSumofweightInversion[iM] += eTemp; 
      eSumofweightTransposition[iN] += eTemp;
      iNumberofproposalsInversion[iM]++;
      iNumberofproposalsTransposition[iN]++;

      eSumofweights1 += (double) iM * eSumofweightInversion[iM]; 
      eSumofweightssquared1 += (double) iM * iM *  eSumofweightInversion[iM] *  eSumofweightInversion[iM] / (double) iNumberofproposalsInversion[iM];
      
      eSumofweights2 += (double) iN * eSumofweightTransposition[iN]; 
      eSumofweightssquared2 += (double) iN * iN *  eSumofweightTransposition[iN] *  eSumofweightTransposition[iN] / (double) iNumberofproposalsTransposition[iN];
 
      iIteration++;
      //fprintf(out,"m: %d n: %d, importanceweight: %le ESS1 = %le ESS2 = %le\n",iM,iN,eTemp,eSumofweights1 * eSumofweights1 / eSumofweightssquared1,eSumofweights2 * eSumofweights2 / eSumofweightssquared2);
      printf("ESS1 = %e ESS2 = %e\n",eSumofweights1 * eSumofweights1 / eSumofweightssquared1,eSumofweights2 * eSumofweights2 / eSumofweightssquared2 ); 
      //printf("m = %d n = %d, eSumofweightssquared1 : %le, eSumofweightssquared2 : %le\n",iM,iN,eSumofweightssquared1,eSumofweightssquared2 );

    }
  }
  fclose(out);
  
  eTemp = 0.0;
  for(iI = 0; iI < 2 * iXX; iI++){
    for(iJ = 0; iJ < 2 * iXX; iJ ++){
      eTemp += eStatistics[iI][iJ];
    }
  }

  for(iI = 0; iI < 2 * iXX; iI++){
    for(iJ = 0; iJ < 2 * iXX; iJ ++){
      eStatistics[iI][iJ] /= eTemp;
    }
  }

  out = fopen("50_length_m10_n0.txt","w");
  for(iI = 0; iI < 2 * iXX; iI++){
    for(iJ = 0; iJ < 2 * iXX; iJ ++){
      fprintf(out,"%e ",eStatistics[iI][iJ]);
    }
    fprintf(out,"\n");
  }

  free(iPermutation);
  for(iI = 0; iI < 2 * iXX; iI++){
    free(eStatistics[iI]);
  }
  free(eStatistics);
  free(eSumofweightInversion);
  free(eSumofweightTransposition);
  free(iPermutation);
  free(iNumberofproposalsInversion);
  free(iNumberofproposalsTransposition);

  return(0);
}

double eNewtrajectory(int iXX,
		      int *iPermutation,
		      int *iN,
		      int *iM){

  double eZ, eNewstep();
//++pac  int iTemppermutation[2*iXX+2], iI, iSorted;
int iTemppermutation[2*XX+2], iI, iSorted;
  int iIntrand();

  *iN=0;
  *iM=0;
  for(iI = 0; iI < 2 * iXX + 2; iI++){
    iTemppermutation[iI] = iPermutation[iI];
  }
  iSorted = 0;
  eZ = 1.0;
  while(iSorted == 0){
    eZ = eZ * eNewstep(iXX,iTemppermutation,iN,iM);
    /*printf("Z: %le\n",eZ);*/
    iSorted = 1;
    for(iI = 0; iI < 2 * iXX + 2; iI++){
      if(iTemppermutation[iI] != iI){
	iSorted=0;
      }
    }
    if(iIntrand(100) == 0 && iSorted == 1){
      eZ *= 0.01;
      iSorted=0;
    }
    
    /*      printf("n: %d, m: %d\n",*n,*m);*/
  }
  eZ = eZ * 0.99;
  // printf("n: %d, m: %d\n",*iN,*iM);
  //scanf("%d\n",&iI);
  return(eZ);
}

double eNewstep(int iXX,
		int *iPermutation,
		int *iN,
		int *iM){

  int iIntrand();
  void Reversion(), Transposition(), Invtransposition1(), Invtransposition2();
  void Swap();
//++pac    int iInvpermutation[2*iXX+2];
  int iInvpermutation[2*XX+2];
  int iI, iIi, iJ, iK, iTemp;
//++pac   int iNumberofcycles, iCyclelength[iXX+2], iNumberofplus[iXX+2],/* iInvcycle[iXX+2],*/ iSign[iXX+2], iTraversed[2*iXX+2];
  int iNumberofcycles, iCyclelength[XX+2], iNumberofplus[XX+2],/* iInvcycle[XX+2],*/ iSign[XX+2], iTraversed[2*XX+2];
//++pac  int p[iXX+1], iActualsign[iXX+1];
  int p[XX+1], iActualsign[XX+1];
//++pac  int iSumsquared, d[iXX+1],  iCyclenumber[iXX+2];
 int iSumsquared, d[XX+1],  iCyclenumber[XX+2];
  int iReverseplus, iReverseminus, iReversesame;
  int iGoodtrans, iGoodinvtrans1, iGoodinvtrans2;
  int iBadtrans, iBadinvtrans1, iBadinvtrans2;
  int iGoodtranslist[5000][3], iGoodinvtranslist1[5000][3], iGoodinvtranslist2[5000][3];
  int iSuperGoodtrans, iSuperGoodinvtrans1, iSuperGoodinvtrans2;
  int iSuperGoodtranslist[5000][3], iSuperGoodinvtranslist1[5000][3], iSuperGoodinvtranslist2[5000][3];
  int iAccepted;
  double eProposal;
  int iGoodall, iSuperGoodall;


//++pac  int iKum0[iXX + 2], iKumPlus1[iXX + 2], iKumMinus11[iXX + 2], iKumMinus12[iXX + 2];
  int iKum0[XX + 2], iKumPlus1[XX + 2], iKumMinus11[XX + 2], iKumMinus12[XX + 2];
//++pac  int iListofpositives[iXX + 2][iXX + 2], iListofnegatives[iXX + 2][iXX + 2];
  int iListofpositives[XX + 2][XX + 2], iListofnegatives[XX + 2][XX + 2];

  /* INVERSE PERMUTATION */

  for(iI = 0; iI < 2 * iXX + 2; iI++){
    iInvpermutation[iPermutation[iI]] = iI;
    iTraversed[iI]=0;
    //printf("%3d ",iPermutation[iI]);
  }
  //printf("\n");

  /* DECOMPOSITION TO CYCLES */

  iNumberofcycles=0;
  iIi=0;
  iGoodtrans=0;
  iGoodinvtrans1=0;
  iGoodinvtrans2=0;
  iSuperGoodtrans=0;
  iSuperGoodinvtrans1=0;
  iSuperGoodinvtrans2=0;
  iKum0[0] = 0;
  iKumPlus1[0] = 0;
  iKumMinus11[0] = 0;
  iKumMinus12[0] = 0;

  while(iIi < 2 * iXX + 2){
    
    /* finding the begining of the cycle */

    //printf("iIi: %d\n",iIi);    

    while(iTraversed[iIi] == 1 && iIi < 2 * iXX + 2){
      iIi++;
    }
   
    //printf("After the while cycle: iIi: %d\n",iIi);    
    
    /* traversing the new cycle*/
    
    if(iIi < 2 * iXX + 2){
      iNumberofcycles++;
      iCyclelength[iNumberofcycles - 1] = 0;
      iNumberofplus[iNumberofcycles - 1] = 0;
      iJ = iIi;
    }
    while(iTraversed[iJ] == 0){
      iTraversed[iJ] = 1;
      iCyclelength[iNumberofcycles - 1]++;
      
      /* finding the next black edge */
      
      if(iJ / 2 == (iJ + 1) / 2){
	//	iInvcycle[iJ / 2] = iNumberofcycles;
	iSign[iJ / 2] = 1;
	iCyclenumber[iJ / 2] = iNumberofcycles;
	iActualsign[iCyclelength[iNumberofcycles - 1] - 1] = 1;
	p[iCyclelength[iNumberofcycles - 1] - 1] = iJ / 2;
	iNumberofplus[iNumberofcycles - 1]++;
	iListofpositives[iNumberofcycles -1][iNumberofplus[iNumberofcycles - 1] - 1] = iJ / 2;
	iJ++;
	iTraversed[iJ] = 1;
      }
      else{
	iJ--;
	//	iInvcycle[iJ / 2] = iNumberofcycles;
	iSign[iJ / 2] = -1;
	iCyclenumber[iJ / 2] = iNumberofcycles;
	iActualsign[iCyclelength[iNumberofcycles - 1] - 1] = -1;
	p[iCyclelength[iNumberofcycles - 1] - 1] = iJ / 2;
	iListofnegatives[iNumberofcycles -1][iCyclelength[iNumberofcycles - 1] - iNumberofplus[iNumberofcycles - 1]-1] = iJ / 2;
	iTraversed[iJ] = 1;
      }
      if(iPermutation[iJ] / 2 == (iPermutation[iJ] + 1) / 2 ){
	iJ = iInvpermutation[iPermutation[iJ] + 1];
      }
      else{
	iJ = iInvpermutation[iPermutation[iJ] - 1];
      }
      
    }

    /* Obtaining the kumulative functions */ 
    
    iKum0[iNumberofcycles - 1] = iNumberofplus[iNumberofcycles - 1]*(iNumberofplus[iNumberofcycles - 1] - 1) + (iCyclelength[iNumberofcycles - 1] - iNumberofplus[iNumberofcycles - 1])*(iCyclelength[iNumberofcycles - 1] - iNumberofplus[iNumberofcycles - 1] - 1);
    iKumPlus1[iNumberofcycles - 1] = iNumberofplus[iNumberofcycles - 1]*(iCyclelength[iNumberofcycles - 1] -iNumberofplus[iNumberofcycles - 1]);
    iKumMinus11[iNumberofcycles - 1] = iCyclelength[iNumberofcycles - 1]*(iXX + 1 - iCyclelength[iNumberofcycles - 1]);
    iKumMinus12[iNumberofcycles - 1] = iCyclelength[iNumberofcycles - 1];
    if(iNumberofcycles > 1){
      iKum0[iNumberofcycles - 1] += iKum0[iNumberofcycles - 2];
      iKumPlus1[iNumberofcycles - 1] += iKumPlus1[iNumberofcycles - 2];
      iKumMinus11[iNumberofcycles - 1] += iKumMinus11[iNumberofcycles - 2];
      iKumMinus12[iNumberofcycles - 1] += iKumMinus12[iNumberofcycles - 2];
    }
    
    /* investigating long cycles */
    
    if(iCyclelength[iNumberofcycles - 1] > 2){
      //printf("Long cycle!, cyclelength: %d\n",iCyclelength[iNumberofcycles - 1]);
      for(iI = 0; iI < iCyclelength[iNumberofcycles - 1] - 2; iI++){
	for(iJ = iI + 1; iJ < iCyclelength[iNumberofcycles - 1] - 1; iJ++){
	  for(iK = iJ + 1; iK < iCyclelength[iNumberofcycles - 1]; iK++){
	    if(p[iI] < p[iJ] && p[iJ] < p[iK]){
	      if(iActualsign[iI] + iActualsign[iJ] + iActualsign[iK] == -3){
		iSuperGoodtranslist[iSuperGoodtrans][0] = p[iI];
		iSuperGoodtranslist[iSuperGoodtrans][1] = p[iJ];
		iSuperGoodtranslist[iSuperGoodtrans][2] = p[iK];
		iSuperGoodtrans++;
		iGoodinvtranslist1[iGoodinvtrans1][0] = p[iI];
		iGoodinvtranslist1[iGoodinvtrans1][1] = p[iJ];
		iGoodinvtranslist1[iGoodinvtrans1][2] = p[iK];
		iGoodinvtrans1++;
		iGoodinvtranslist2[iGoodinvtrans2][0] = p[iI];
		iGoodinvtranslist2[iGoodinvtrans2][1] = p[iJ];
		iGoodinvtranslist2[iGoodinvtrans2][2] = p[iK];
		iGoodinvtrans2++;
	      }
	      
	      if(iActualsign[iI]==1&&iActualsign[iJ]==-1&&iActualsign[iK]==-1){
		iGoodtranslist[iGoodtrans][0] = p[iI];
		iGoodtranslist[iGoodtrans][1] = p[iJ];
		iGoodtranslist[iGoodtrans][2] = p[iK];
		iGoodtrans++;
	      }
	      
	      if(iActualsign[iI]==-1&&iActualsign[iJ]*iActualsign[iK]==-1){
		iGoodtranslist[iGoodtrans][0] = p[iI];
		iGoodtranslist[iGoodtrans][1] = p[iJ];
		iGoodtranslist[iGoodtrans][2] = p[iK];
		iGoodtrans++;
	      }
	      
	      if((iActualsign[iI]==1) && (iActualsign[iJ]==1) && (iActualsign[iK]==-1)){
		iGoodinvtranslist2[iGoodinvtrans2][0] = p[iI];
		iGoodinvtranslist2[iGoodinvtrans2][1] = p[iJ];
		iGoodinvtranslist2[iGoodinvtrans2][2] = p[iK];
		iGoodinvtrans2++;
	      }
	      if((iActualsign[iI]==1) && (iActualsign[iJ]==-1) && (iActualsign[iK]==-1)){
		iSuperGoodinvtranslist2[iSuperGoodinvtrans2][0] = p[iI];
		iSuperGoodinvtranslist2[iSuperGoodinvtrans2][1] = p[iJ];
		iSuperGoodinvtranslist2[iSuperGoodinvtrans2][2] = p[iK];
		iSuperGoodinvtrans2++;
	      }
	      
	      
	      if((iActualsign[iI]==-1) && (iActualsign[iJ]==1) && (iActualsign[iK]==1)){
		iGoodinvtranslist1[iGoodinvtrans1][0] = p[iI];
		iGoodinvtranslist1[iGoodinvtrans1][1] = p[iJ];
		iGoodinvtranslist1[iGoodinvtrans1][2] = p[iK];
		iGoodinvtrans1++;
	      }

	      if((iActualsign[iI]==-1) && (iActualsign[iJ]==-1) && (iActualsign[iK]==1)){
		iSuperGoodinvtranslist1[iSuperGoodinvtrans1][0] = p[iI];
		iSuperGoodinvtranslist1[iSuperGoodinvtrans1][1] = p[iJ];
		iSuperGoodinvtranslist1[iSuperGoodinvtrans1][2] = p[iK];
		iSuperGoodinvtrans1++;
	      }
	      
	      if((iActualsign[iI]==1) && (iActualsign[iJ]==-1) && (iActualsign[iK]==1)){
		iGoodinvtranslist1[iGoodinvtrans1][0] = p[iI];
		iGoodinvtranslist1[iGoodinvtrans1][1] = p[iJ];
		iGoodinvtranslist1[iGoodinvtrans1][2] = p[iK];
		iGoodinvtrans1++;
		iGoodinvtranslist2[iGoodinvtrans2][0] = p[iI];
		iGoodinvtranslist2[iGoodinvtrans2][1] = p[iJ];
		iGoodinvtranslist2[iGoodinvtrans2][2] = p[iK];
		iGoodinvtrans2++;
	      }
	      
	    }
	    
	    if(p[iI]<p[iK]&&p[iK]<p[iJ]){
	      if(iActualsign[iI]+iActualsign[iJ]+iActualsign[iK]==3){
		iSuperGoodtranslist[iSuperGoodtrans][0] = p[iI];
		iSuperGoodtranslist[iSuperGoodtrans][1] = p[iJ];
		iSuperGoodtranslist[iSuperGoodtrans][2] = p[iK];
		iSuperGoodtrans++;
		iGoodinvtranslist1[iGoodinvtrans1][0] = p[iI];
		iGoodinvtranslist1[iGoodinvtrans1][1] = p[iJ];
		iGoodinvtranslist1[iGoodinvtrans1][2] = p[iK];
		iGoodinvtrans1++;
		iGoodinvtranslist2[iGoodinvtrans2][0] = p[iI];
		iGoodinvtranslist2[iGoodinvtrans2][1] = p[iJ];
		iGoodinvtranslist2[iGoodinvtrans2][2] = p[iK];
		iGoodinvtrans2++;
	      }
	      
	      if(iActualsign[iI]==-1&&iActualsign[iJ]==1&&iActualsign[iK]==1){
		iGoodtranslist[iGoodtrans][0] = p[iI];
		iGoodtranslist[iGoodtrans][1] = p[iJ];
		iGoodtranslist[iGoodtrans][2] = p[iK];
		iGoodtrans++;
	      }
	      
	      if(iActualsign[iI]==1&&iActualsign[iJ]*iActualsign[iK]==-1){
		iGoodtranslist[iGoodtrans][0] = p[iI];
		iGoodtranslist[iGoodtrans][1] = p[iJ];
		iGoodtranslist[iGoodtrans][2] = p[iK];
		iGoodtrans++;
	      }		    		      
	      
	      if(iActualsign[iI]==-1&&iActualsign[iJ]==1&&iActualsign[iK]==-1){
		iGoodinvtranslist2[iGoodinvtrans2][0] = p[iI];
		iGoodinvtranslist2[iGoodinvtrans2][1] = p[iJ];
		iGoodinvtranslist2[iGoodinvtrans2][2] = p[iK];
		iGoodinvtrans2++;
	      }
	      if(iActualsign[iI]==-1&&iActualsign[iJ]==1&&iActualsign[iK]==1){
		iSuperGoodinvtranslist2[iSuperGoodinvtrans2][0] = p[iI];
		iSuperGoodinvtranslist2[iSuperGoodinvtrans2][1] = p[iJ];
		iSuperGoodinvtranslist2[iSuperGoodinvtrans2][2] = p[iK];
		iSuperGoodinvtrans2++;
	      }
	      
	      
	      if(iActualsign[iI]==1&&iActualsign[iJ]==-1&&iActualsign[iK]==-1){
		iGoodinvtranslist1[iGoodinvtrans1][0] = p[iI];
		iGoodinvtranslist1[iGoodinvtrans1][1] = p[iJ];
		iGoodinvtranslist1[iGoodinvtrans1][2] = p[iK];
		iGoodinvtrans1++;
	      }
	      if(iActualsign[iI]==1&&iActualsign[iJ]==-1&&iActualsign[iK]==1){
		iSuperGoodinvtranslist1[iSuperGoodinvtrans1][0] = p[iI];
		iSuperGoodinvtranslist1[iSuperGoodinvtrans1][1] = p[iJ];
		iSuperGoodinvtranslist1[iSuperGoodinvtrans1][2] = p[iK];
		iSuperGoodinvtrans1++;
	      }
	      
	      if((iActualsign[iI]==-1) && (iActualsign[iJ]==-1) && (iActualsign[iK]==1)){
		iGoodinvtranslist1[iGoodinvtrans1][0] = p[iI];
		iGoodinvtranslist1[iGoodinvtrans1][1] = p[iJ];
		iGoodinvtranslist1[iGoodinvtrans1][2] = p[iK];
		iGoodinvtrans1++;
		iGoodinvtranslist2[iGoodinvtrans2][0] = p[iI];
		iGoodinvtranslist2[iGoodinvtrans2][1] = p[iJ];
		iGoodinvtranslist2[iGoodinvtrans2][2] = p[iK];
		iGoodinvtrans2++;
	      }
	    }
	    if(p[iJ]<p[iI]&&p[iI]<p[iK]){
	      if(iActualsign[iI]+iActualsign[iJ]+iActualsign[iK]==3){
		iSuperGoodtranslist[iSuperGoodtrans][0] = p[iI];
		iSuperGoodtranslist[iSuperGoodtrans][1] = p[iJ];
		iSuperGoodtranslist[iSuperGoodtrans][2] = p[iK];
		iSuperGoodtrans++;
		iGoodinvtranslist1[iGoodinvtrans1][0] = p[iI];
		iGoodinvtranslist1[iGoodinvtrans1][1] = p[iJ];
		iGoodinvtranslist1[iGoodinvtrans1][2] = p[iK];
		iGoodinvtrans1++;
		iGoodinvtranslist2[iGoodinvtrans2][0] = p[iI];
		iGoodinvtranslist2[iGoodinvtrans2][1] = p[iJ];
		iGoodinvtranslist2[iGoodinvtrans2][2] = p[iK];
		iGoodinvtrans2++;
	      }
	      
	      if(iActualsign[iI]==1&&iActualsign[iJ]==-1&&iActualsign[iK]==1){
		iGoodtranslist[iGoodtrans][0] = p[iI];
		iGoodtranslist[iGoodtrans][1] = p[iJ];
		iGoodtranslist[iGoodtrans][2] = p[iK];
		iGoodtrans++;
	      }
	      
	      if(iActualsign[iJ]==1&&iActualsign[iI]*iActualsign[iK]==-1){
		iGoodtranslist[iGoodtrans][0] = p[iI];
		iGoodtranslist[iGoodtrans][1] = p[iJ];
		iGoodtranslist[iGoodtrans][2] = p[iK];
		iGoodtrans++;
	      }
	      
	      if(iActualsign[iJ]==-1&&iActualsign[iK]==1&&iActualsign[iI]==-1){
		iGoodinvtranslist2[iGoodinvtrans2][0] = p[iI];
		iGoodinvtranslist2[iGoodinvtrans2][1] = p[iJ];
		iGoodinvtranslist2[iGoodinvtrans2][2] = p[iK];
		iGoodinvtrans2++;
	      }
	      if(iActualsign[iJ]==-1&&iActualsign[iK]==1&&iActualsign[iI]==1){
		iSuperGoodinvtranslist2[iSuperGoodinvtrans2][0] = p[iI];
		iSuperGoodinvtranslist2[iSuperGoodinvtrans2][1] = p[iJ];
		iSuperGoodinvtranslist2[iSuperGoodinvtrans2][2] = p[iK];
		iSuperGoodinvtrans2++;
	      }
	      
	      
	      if(iActualsign[iJ]==1&&iActualsign[iK]==-1&&iActualsign[iI]==-1){
		iGoodinvtranslist1[iGoodinvtrans1][0] = p[iI];
		iGoodinvtranslist1[iGoodinvtrans1][1] = p[iJ];
		iGoodinvtranslist1[iGoodinvtrans1][2] = p[iK];
		iGoodinvtrans1++;
	      }
	      if(iActualsign[iJ]==1&&iActualsign[iK]==-1&&iActualsign[iI]==1){
		iSuperGoodinvtranslist1[iSuperGoodinvtrans1][0] = p[iI];
		iSuperGoodinvtranslist1[iSuperGoodinvtrans1][1] = p[iJ];
		iSuperGoodinvtranslist1[iSuperGoodinvtrans1][2] = p[iK];
		iSuperGoodinvtrans1++;
	      }
	      
	      if((iActualsign[iI]==1) && (iActualsign[iJ]==-1) && (iActualsign[iK]==-1)){
		iGoodinvtranslist1[iGoodinvtrans1][0] = p[iI];
		iGoodinvtranslist1[iGoodinvtrans1][1] = p[iJ];
		iGoodinvtranslist1[iGoodinvtrans1][2] = p[iK];
		iGoodinvtrans1++;
		iGoodinvtranslist2[iGoodinvtrans2][0] = p[iI];
		iGoodinvtranslist2[iGoodinvtrans2][1] = p[iJ];
		iGoodinvtranslist2[iGoodinvtrans2][2] = p[iK];
		iGoodinvtrans2++;
	      }
	      
	    }
	    if(p[iJ]<p[iK]&&p[iK]<p[iI]){
	      if(iActualsign[iI]+iActualsign[iJ]+iActualsign[iK]==-3){
		iSuperGoodtranslist[iSuperGoodtrans][0] = p[iI];
		iSuperGoodtranslist[iSuperGoodtrans][1] = p[iJ];
		iSuperGoodtranslist[iSuperGoodtrans][2] = p[iK];
		iSuperGoodtrans++;
		iGoodinvtranslist1[iGoodinvtrans1][0] = p[iI];
		iGoodinvtranslist1[iGoodinvtrans1][1] = p[iJ];
		iGoodinvtranslist1[iGoodinvtrans1][2] = p[iK];
		iGoodinvtrans1++;
		iGoodinvtranslist2[iGoodinvtrans2][0] = p[iI];
		iGoodinvtranslist2[iGoodinvtrans2][1] = p[iJ];
		iGoodinvtranslist2[iGoodinvtrans2][2] = p[iK];
		iGoodinvtrans2++;
	      }
	      
	      if(iActualsign[iI]==-1&&iActualsign[iJ]==1&&iActualsign[iK]==-1){
		iGoodtranslist[iGoodtrans][0] = p[iI];
		iGoodtranslist[iGoodtrans][1] = p[iJ];
		iGoodtranslist[iGoodtrans][2] = p[iK];
		iGoodtrans++;
	      }
	      
	      if(iActualsign[iJ]==-1&&iActualsign[iI]*iActualsign[iK]==-1){
		iGoodtranslist[iGoodtrans][0] = p[iI];
		iGoodtranslist[iGoodtrans][1] = p[iJ];
		iGoodtranslist[iGoodtrans][2] = p[iK];
		iGoodtrans++;
	      }
	      
	      if(iActualsign[iI]==-1&&iActualsign[iJ]==1&&iActualsign[iK]==1){
		iGoodinvtranslist2[iGoodinvtrans2][0] = p[iI];
		iGoodinvtranslist2[iGoodinvtrans2][1] = p[iJ];
		iGoodinvtranslist2[iGoodinvtrans2][2] = p[iK];
		iGoodinvtrans2++;
	      }
	      if(iActualsign[iI]==-1&&iActualsign[iJ]==1&&iActualsign[iK]==-1){
		iSuperGoodinvtranslist2[iSuperGoodinvtrans2][0] = p[iI];
		iSuperGoodinvtranslist2[iSuperGoodinvtrans2][1] = p[iJ];
		iSuperGoodinvtranslist2[iSuperGoodinvtrans2][2] = p[iK];
		iSuperGoodinvtrans2++;
	      }
	      
	      
	      if(iActualsign[iI]==1&&iActualsign[iJ]==-1&&iActualsign[iK]==1){
		iGoodinvtranslist1[iGoodinvtrans1][0] = p[iI];
		iGoodinvtranslist1[iGoodinvtrans1][1] = p[iJ];
		iGoodinvtranslist1[iGoodinvtrans1][2] = p[iK];
		iGoodinvtrans1++;
	      }
	      if(iActualsign[iI]==1&&iActualsign[iJ]==-1&&iActualsign[iK]==-1){
		iSuperGoodinvtranslist1[iSuperGoodinvtrans1][0] = p[iI];
		iSuperGoodinvtranslist1[iSuperGoodinvtrans1][1] = p[iJ];
		iSuperGoodinvtranslist1[iSuperGoodinvtrans1][2] = p[iK];
		iSuperGoodinvtrans1++;
	      }
	      
	      if((iActualsign[iI]==1) && (iActualsign[iJ]==1) && (iActualsign[iK]==-1)){
		iGoodinvtranslist1[iGoodinvtrans1][0] = p[iI];
		iGoodinvtranslist1[iGoodinvtrans1][1] = p[iJ];
		iGoodinvtranslist1[iGoodinvtrans1][2] = p[iK];
		iGoodinvtrans1++;
		iGoodinvtranslist2[iGoodinvtrans2][0] = p[iI];
		iGoodinvtranslist2[iGoodinvtrans2][1] = p[iJ];
		iGoodinvtranslist2[iGoodinvtrans2][2] = p[iK];
		iGoodinvtrans2++;
	      }
	      
	    }
	    if(p[iK]<p[iI]&&p[iI]<p[iJ]){
	      if(iActualsign[iI]+iActualsign[iJ]+iActualsign[iK]==-3){
		iSuperGoodtranslist[iSuperGoodtrans][0] = p[iI];
		iSuperGoodtranslist[iSuperGoodtrans][1] = p[iJ];
		iSuperGoodtranslist[iSuperGoodtrans][2] = p[iK];
		iSuperGoodtrans++;
		iGoodinvtranslist1[iGoodinvtrans1][0] = p[iI];
		iGoodinvtranslist1[iGoodinvtrans1][1] = p[iJ];
		iGoodinvtranslist1[iGoodinvtrans1][2] = p[iK];
		iGoodinvtrans1++;
		iGoodinvtranslist2[iGoodinvtrans2][0] = p[iI];
		iGoodinvtranslist2[iGoodinvtrans2][1] = p[iJ];
		iGoodinvtranslist2[iGoodinvtrans2][2] = p[iK];
		iGoodinvtrans2++;
	      }			
	      
	      if(iActualsign[iI]==-1&&iActualsign[iJ]==-1&&iActualsign[iK]==1){
		iGoodtranslist[iGoodtrans][0] = p[iI];
		iGoodtranslist[iGoodtrans][1] = p[iJ];
		iGoodtranslist[iGoodtrans][2] = p[iK];
		iGoodtrans++;
	      }
	      
	      if(iActualsign[iK]==-1&&iActualsign[iI]*iActualsign[iJ]==-1){
		iGoodtranslist[iGoodtrans][0] = p[iI];
		iGoodtranslist[iGoodtrans][1] = p[iJ];
		iGoodtranslist[iGoodtrans][2] = p[iK];
		iGoodtrans++;
	      }
	      
	      if(iActualsign[iJ]==-1&&iActualsign[iK]==1&&iActualsign[iI]==1){
		iGoodinvtranslist2[iGoodinvtrans2][0] = p[iI];
		iGoodinvtranslist2[iGoodinvtrans2][1] = p[iJ];
		iGoodinvtranslist2[iGoodinvtrans2][2] = p[iK];
		iGoodinvtrans2++;
	      }
	      if(iActualsign[iJ]==-1&&iActualsign[iK]==1&&iActualsign[iI]==-1){
		iSuperGoodinvtranslist2[iSuperGoodinvtrans2][0] = p[iI];
		iSuperGoodinvtranslist2[iSuperGoodinvtrans2][1] = p[iJ];
		iSuperGoodinvtranslist2[iSuperGoodinvtrans2][2] = p[iK];
		iSuperGoodinvtrans2++;
	      }
	      
	      
	      if(iActualsign[iJ]==1&&iActualsign[iK]==-1&&iActualsign[iI]==1){
		iGoodinvtranslist1[iGoodinvtrans1][0] = p[iI];
		iGoodinvtranslist1[iGoodinvtrans1][1] = p[iJ];
		iGoodinvtranslist1[iGoodinvtrans1][2] = p[iK];
		iGoodinvtrans1++;
	      }
	      if(iActualsign[iJ]==1&&iActualsign[iK]==-1&&iActualsign[iI]==-11){
		iSuperGoodinvtranslist1[iSuperGoodinvtrans1][0] = p[iI];
		iSuperGoodinvtranslist1[iSuperGoodinvtrans1][1] = p[iJ];
		iSuperGoodinvtranslist1[iSuperGoodinvtrans1][2] = p[iK];
		iSuperGoodinvtrans1++;
	      }
	      
	      if((iActualsign[iI]==-1) && (iActualsign[iJ]==1) && (iActualsign[iK]==1)){
		iGoodinvtranslist1[iGoodinvtrans1][0] = p[iI];
		iGoodinvtranslist1[iGoodinvtrans1][1] = p[iJ];
		iGoodinvtranslist1[iGoodinvtrans1][2] = p[iK];
		iGoodinvtrans1++;
		iGoodinvtranslist2[iGoodinvtrans2][0] = p[iI];
		iGoodinvtranslist2[iGoodinvtrans2][1] = p[iJ];
		iGoodinvtranslist2[iGoodinvtrans2][2] = p[iK];
		iGoodinvtrans2++;
	      }
	    }
	    if(p[iK]<p[iJ]&&p[iJ]<p[iI]){
	      if(iActualsign[iI]+iActualsign[iJ]+iActualsign[iK]==3)
		{
		  iSuperGoodtranslist[iSuperGoodtrans][0] = p[iI];
		  iSuperGoodtranslist[iSuperGoodtrans][1] = p[iJ];
		  iSuperGoodtranslist[iSuperGoodtrans][2] = p[iK];
		  iSuperGoodtrans++;
		  iGoodinvtranslist1[iGoodinvtrans1][0] = p[iI];
		  iGoodinvtranslist1[iGoodinvtrans1][1] = p[iJ];
		  iGoodinvtranslist1[iGoodinvtrans1][2] = p[iK];
		  iGoodinvtrans1++;
		  iGoodinvtranslist2[iGoodinvtrans2][0] = p[iI];
		  iGoodinvtranslist2[iGoodinvtrans2][1] = p[iJ];
		  iGoodinvtranslist2[iGoodinvtrans2][2] = p[iK];
		  iGoodinvtrans2++;
		}
	      
	      if(iActualsign[iI]==1&&iActualsign[iJ]==1&&iActualsign[iK]==-1){
		iGoodtranslist[iGoodtrans][0] = p[iI];
		iGoodtranslist[iGoodtrans][1] = p[iJ];
		iGoodtranslist[iGoodtrans][2] = p[iK];
		iGoodtrans++;
	      }
	      
	      if(iActualsign[iK]==1&&iActualsign[iI]*iActualsign[iJ]==-1){
		iGoodtranslist[iGoodtrans][0] = p[iI];
		iGoodtranslist[iGoodtrans][1] = p[iJ];
		iGoodtranslist[iGoodtrans][2] = p[iK];
		iGoodtrans++;
	      }
	      
	      if(iActualsign[iI]==1&&iActualsign[iK]==-1&&iActualsign[iJ]==-1){
		iGoodinvtranslist2[iGoodinvtrans2][0] = p[iI];
		iGoodinvtranslist2[iGoodinvtrans2][1] = p[iJ];
		iGoodinvtranslist2[iGoodinvtrans2][2] = p[iK];
		iGoodinvtrans2++;
	      }
	      if(iActualsign[iI]==1&&iActualsign[iK]==-1&&iActualsign[iJ]==1){
		iSuperGoodinvtranslist2[iSuperGoodinvtrans2][0] = p[iI];
		iSuperGoodinvtranslist2[iSuperGoodinvtrans2][1] = p[iJ];
		iSuperGoodinvtranslist2[iSuperGoodinvtrans2][2] = p[iK];
		iSuperGoodinvtrans2++;
	      }
	      
	      
	      if(iActualsign[iI]==-1&&iActualsign[iK]==1&&iActualsign[iJ]==-1){
		iGoodinvtranslist1[iGoodinvtrans1][0] = p[iI];
		iGoodinvtranslist1[iGoodinvtrans1][1] = p[iJ];
		iGoodinvtranslist1[iGoodinvtrans1][2] = p[iK];
		iGoodinvtrans1++;
	      }
	      if(iActualsign[iI]==-1&&iActualsign[iK]==1&&iActualsign[iJ]==1){
		iSuperGoodinvtranslist1[iSuperGoodinvtrans1][0] = p[iI];
		iSuperGoodinvtranslist1[iSuperGoodinvtrans1][1] = p[iJ];
		iSuperGoodinvtranslist1[iSuperGoodinvtrans1][2] = p[iK];
		iSuperGoodinvtrans1++;
	      }
	      
	      if((iActualsign[iI]==-1) && (iActualsign[iJ]==1) && (iActualsign[iK]==-1)){
		iGoodinvtranslist1[iGoodinvtrans1][0] = p[iI];
		iGoodinvtranslist1[iGoodinvtrans1][1] = p[iJ];
		iGoodinvtranslist1[iGoodinvtrans1][2] = p[iK];
		iGoodinvtrans1++;
		iGoodinvtranslist2[iGoodinvtrans2][0] = p[iI];			  
		iGoodinvtranslist2[iGoodinvtrans2][1] = p[iJ];
		iGoodinvtranslist2[iGoodinvtrans2][2] = p[iK];
		iGoodinvtrans2++;
	      }
	      
	    }
	  }
	}
      }
    }
  }

  
  
  iSumsquared=0;
  iReverseplus=0;
  for(iI = 0; iI < iNumberofcycles; iI++){
    iSumsquared+=iCyclelength[iI]*(iCyclelength[iI]-1);
    d[iI]=(iCyclelength[iI]-iNumberofplus[iI])*iNumberofplus[iI];
    iReverseplus+=d[iI];
  }
  iReverseminus=((iXX+1)*iXX-iSumsquared)/2;
  iReversesame=(iXX+1)*iXX/2-iReverseplus-iReverseminus;
  
  /* PROPOSING A NEW STEP */

  eProposal = 1.0;

  iGoodall = iGoodtrans + iGoodinvtrans1 + iGoodinvtrans2;
  iSuperGoodall = iSuperGoodtrans + iSuperGoodinvtrans1 + iSuperGoodinvtrans2;

  /* bening mutation */
  if(iGoodall + iSuperGoodall + iReverseplus > 0 && iIntrand(100) != 0){
    eProposal *= 0.99;
    /* 2-transposition */
    if(iSuperGoodall > 0 && iIntrand(100) < 50){
      eProposal *= 0.5/(double)iSuperGoodall;
      iTemp = iIntrand(iSuperGoodall);
      if(iTemp < iSuperGoodtrans){
	iTemp = iIntrand(iSuperGoodtrans);
	iI = iSuperGoodtranslist[iTemp][0];
	iJ = iSuperGoodtranslist[iTemp][1];
	iK = iSuperGoodtranslist[iTemp][2];
	if(iI > iJ){
	  Swap(&iI,&iJ);
	}
	if(iI > iK){
	  Swap(&iI,&iK);
	}
	if(iJ > iK){
	  Swap(&iJ,&iK);
	}
	Transposition(iXX,iPermutation,iI,iJ,iK);
	//printf("Transposition, Super i: %d, j: %d, k: %d\n",iI,iJ,iK);
	  (*iN)++;
      }
      else if(iTemp < iSuperGoodtrans + iSuperGoodinvtrans1){
	iTemp = iIntrand(iSuperGoodinvtrans1);
	iI = iSuperGoodinvtranslist1[iTemp][0];
	iJ = iSuperGoodinvtranslist1[iTemp][1];
	iK = iSuperGoodinvtranslist1[iTemp][2];
	if(iI > iJ){
	  Swap(&iI,&iJ);
	}
	if(iI > iK){
	  Swap(&iI,&iK);
	}
	if(iJ > iK){
	  Swap(&iJ,&iK);
	}
	Invtransposition1(iXX,iPermutation,iI,iJ,iK);
	//printf("Invtransposition1, Super i: %d, j: %d, k: %d\n",iI,iJ,iK);
	(*iN)++;
      }
      else{
	iTemp = iIntrand(iSuperGoodinvtrans2);
	iI = iSuperGoodinvtranslist2[iTemp][0];
	iJ = iSuperGoodinvtranslist2[iTemp][1];
	iK = iSuperGoodinvtranslist2[iTemp][2];
	if(iI > iJ){
	  Swap(&iI,&iJ);
	}
	if(iI > iK){
	  Swap(&iI,&iK);
	}
	if(iJ > iK){
	  Swap(&iJ,&iK);
	}
	Invtransposition2(iXX,iPermutation,iI,iJ,iK);
	//printf("Invtransposition2, Super i: %d, j: %d, k: %d\n",iI,iJ,iK);
	(*iN)++;
      }
    }
    /* 1-transposition or 1-inversion */
    else{
      if(iSuperGoodall != 0){
	eProposal *= 0.5;
      }
      eProposal /= (double) (iSuperGoodall + iReverseplus);
      iTemp = iIntrand(iSuperGoodall + iReverseplus);
      if(iTemp < iGoodtrans){
	iTemp = iIntrand(iGoodtrans);
	iI = iGoodtranslist[iTemp][0];
	iJ = iGoodtranslist[iTemp][1];
	iK = iGoodtranslist[iTemp][2];
	if(iI > iJ){
	  Swap(&iI,&iJ);
	}
	if(iI > iK){
	  Swap(&iI,&iK);
	}
	if(iJ > iK){
	  Swap(&iJ,&iK);
	}
	//printf("Transposition, good i: %d, j: %d, k: %d\n",iI,iJ,iK);
	Transposition(iXX,iPermutation,iI,iJ,iK);
	(*iN)++;
      }
      else if(iTemp < iGoodtrans + iGoodinvtrans1){
	iTemp = iIntrand(iGoodinvtrans1);
	iI = iGoodinvtranslist1[iTemp][0];
	iJ = iGoodinvtranslist1[iTemp][1];
	iK = iGoodinvtranslist1[iTemp][2];
	if(iI > iJ){
	  Swap(&iI,&iJ);
	}
	if(iI > iK){
	  Swap(&iI,&iK);
	}
	if(iJ > iK){
	  Swap(&iJ,&iK);
	}
	//printf("Invtransposition1, good i: %d, j: %d, k: %d\n",iI,iJ,iK);
	Invtransposition1(iXX,iPermutation,iI,iJ,iK);
	(*iN)++;
      }
      else if(iTemp < iGoodtrans + iGoodinvtrans1 + iGoodinvtrans2){
	iTemp = iIntrand(iGoodinvtrans2);
	iI = iGoodinvtranslist2[iTemp][0];
	iJ = iGoodinvtranslist2[iTemp][1];
	iK = iGoodinvtranslist2[iTemp][2];
	if(iI > iJ){
	  Swap(&iI,&iJ);
	}
	if(iI > iK){
	  Swap(&iI,&iK);
	}
	if(iJ > iK){
	  Swap(&iJ,&iK);
	}
	//printf("Invtransposition2, good i: %d, j: %d, k: %d\n",iI,iJ,iK);
	Invtransposition2(iXX,iPermutation,iI,iJ,iK);
	(*iN)++;
      }
      else{
	/* +1-inversion */
	iTemp = iIntrand(iKumPlus1[iNumberofcycles - 1]);
	//	printf("Temp:%d\n",iTemp);
	//	for(iI = 0; iI < iNumberofcycles; iI++){
	// printf("iKumPlus1[i]: %d\n",iKumPlus1[iI]);
	//}
	for(iK = 0; iTemp >= iKumPlus1[iK]; iK++);
	//printf("k: %d\n",iK);
	//printf("iCyclelength[iK]: %d\n",iCyclelength[iK]);
	//printf("iNumberofplus[iK]: %d\n",iNumberofplus[iK]);

	iI = iListofnegatives[iK][iIntrand(iCyclelength[iK] - iNumberofplus[iK])];
	iJ = iListofpositives[iK][iIntrand(iNumberofplus[iK])];
	if(iI > iJ){
	  Swap(&iI,&iJ);
	}
	//printf("Inversion, +1 i: %d, j: %d\n",iI,iJ);
	Reversion(iXX,iPermutation,iI,iJ);
	(*iM)++;
       }
    }
  }
  /* 0-inversion */
  else if((iReversesame > 0 && iIntrand(100) < 50) || (iReverseminus == 0 && 2 * (iGoodall + iSuperGoodall) == iXX * iXX * iXX - iXX)){
    if(iGoodall + iSuperGoodall + iReverseplus != 0){
      eProposal *= 0.01;
    }
    if(iReverseminus != 0 || 2*(iGoodall + iSuperGoodall) != iXX * iXX * iXX - iXX){
      eProposal *= 0.5;
    }
    iTemp = iIntrand(iKum0[iNumberofcycles - 1]);
    for(iK = 0; iTemp >= iKum0[iK]; iK++);
    iTemp = iIntrand(iNumberofplus[iK] * (iNumberofplus[iK] - 1) + (iCyclelength[iK] - iNumberofplus[iK]) * (iCyclelength[iK] - iNumberofplus[iK] - 1) );
    if(iTemp < iNumberofplus[iK] * (iNumberofplus[iK] - 1)){
      iI = iListofpositives[iK][iIntrand(iNumberofplus[iK])];
      iJ = iI;
      while(iJ == iI){
	iJ = iListofpositives[iK][iIntrand(iNumberofplus[iK])];
      }
      if(iI > iJ){
	Swap(&iI,&iJ);
      }
      //printf("Inversion, 0 i: %d, j: %d\n",iI,iJ);
      Reversion(iXX,iPermutation,iI,iJ);
      (*iM)++;
    }
    else{
      iI = iListofnegatives[iK][iIntrand(iCyclelength[iK] - iNumberofplus[iK])];
      iJ = iI;
      while(iJ == iI){
	iJ = iListofnegatives[iK][iIntrand(iCyclelength[iK] - iNumberofplus[iK])];
      }
      if(iI > iJ){
	Swap(&iI,&iJ);
      }
      //printf("Inversion, 0' i: %d, j: %d\n",iI,iJ);
      Reversion(iXX,iPermutation,iI,iJ);
      (*iM)++;
    }
  }
  /* -1-inversion */
  else if(iReverseminus > 0 && iIntrand(100) < 80){
    eProposal = 0.8;
    if(iGoodall + iSuperGoodall + iReverseplus != 0){
      eProposal *= 0.01;
    }
    if(iReversesame > 0){
      eProposal *= 0.5;
    }
    eProposal /= (double) iReverseminus;
    /*
    iTemp = iIntrand(iKumMinus11[iNumberofcycles - 1]);
    for(iK = 0; iTemp >= iKumMinus11[iK]; iK++);
    iTemp = iIntrand(iCyclelength[iK]);
    if(iTemp < iNumberofplus[iK]){
      iI = iListofpositives[iK][iIntrand(iNumberofplus[iK])];
    }
    else{
      iI = iListofnegatives[iK][iIntrand(iCyclelength[iK] - iNumberofplus[iK])];
    }
    iTemp = iIntrand(iKumMinus12[iNumberofcycles - 1] - iKumMinus12[iK]);
    for(iL = 0; iTemp >= iKumMinus12[iL]; iL++){
      if(iL == iK - 1){
	iTemp += iCyclelength[iK];
      }
    }
    iTemp = iIntrand(iCyclelength[iL]);
    if(iTemp < iNumberofplus[iL]){
      iJ = iListofpositives[iL][iIntrand(iNumberofplus[iL])];
    }
    else{
      iJ = iListofnegatives[iL][iIntrand(iCyclelength[iL] - iNumberofplus[iL])];
    }
    if(iI > iJ){
      Swap(&iI,&iJ);
    }
    */
    //printf("Inversion, -1 i: %d, j: %d\n",iI,iJ);
    iAccepted = 0;
    while(iAccepted == 0){
      iI = iIntrand(iXX + 1);
      iJ = iIntrand(iXX);
      if(iJ == iI){
	iJ++;
      }
      if(iI > iJ){
	Swap(&iI,&iJ);
      }
      if(iCyclenumber[iI] != iCyclenumber[iJ]){
	iAccepted = 1;
      }
    }
    Reversion(iXX,iPermutation,iI,iJ);
    (*iM)++;
  }
  /* non-benign transposition */
  else{
    if(iGoodall + iSuperGoodall + iReverseplus != 0){
      eProposal *= 0.01;
    }
    if(iReversesame > 0){
      eProposal *= 0.5;
    }
    if(iReverseminus > 0){
      eProposal *= 0.2;
    }

    /**********************************************************************************************/
      iBadtrans=((iXX+1)*iXX*(iXX-1)/6)-iGoodtrans - iSuperGoodtrans;
      iBadinvtrans1=((iXX+1)*iXX*(iXX-1)/6)-iGoodinvtrans1 - iSuperGoodinvtrans1;
      iBadinvtrans2=((iXX+1)*iXX*(iXX-1)/6)-iGoodinvtrans2 - iSuperGoodinvtrans2;

      iAccepted=0;
      if(iIntrand(iBadtrans+iBadinvtrans1+iBadinvtrans2)<iBadtrans){
	while(iAccepted==0){
	  /* transposition */
	  iI=iIntrand(iXX+1);
	  iJ=iIntrand(iXX);
	  if(iJ>=iI){
	    iJ++;
	  }
	  else{
	    Swap(&iI,&iJ);
	  }
	  iK=iIntrand(iXX-1);
	  if(iK>=iI)
	    iK++;
	  if(iK>=iJ)
	    iK++;
	  if(iK<iI){
	    Swap(&iK,&iI);
	    Swap(&iK,&iJ);
	  }
	  if(iK<iJ){
	    Swap(&iK,&iJ);
	  }	  
	  iAccepted=1;
	  for(iTemp=0;iTemp<iGoodtrans;iTemp++){
	    if(iI==iGoodtranslist[iTemp][0]&&iJ==iGoodtranslist[iTemp][1]&&iK==iGoodtranslist[iTemp][2])
	      iAccepted=0;
	    if(iI==iGoodtranslist[iTemp][0]&&iK==iGoodtranslist[iTemp][1]&&iJ==iGoodtranslist[iTemp][2])
	      iAccepted=0;
	    if(iJ==iGoodtranslist[iTemp][0]&&iI==iGoodtranslist[iTemp][1]&&iK==iGoodtranslist[iTemp][2])
	      iAccepted=0;
	    if(iJ==iGoodtranslist[iTemp][0]&&iK==iGoodtranslist[iTemp][1]&&iI==iGoodtranslist[iTemp][2])
	      iAccepted=0;
	    if(iK==iGoodtranslist[iTemp][0]&&iI==iGoodtranslist[iTemp][1]&&iJ==iGoodtranslist[iTemp][2])
	      iAccepted=0;
	    if(iK==iGoodtranslist[iTemp][0]&&iJ==iGoodtranslist[iTemp][1]&&iI==iGoodtranslist[iTemp][2])
	      iAccepted=0;
	  }
	  for(iTemp=0;iTemp<iSuperGoodtrans;iTemp++){
	    if(iI==iSuperGoodtranslist[iTemp][0]&&iJ==iSuperGoodtranslist[iTemp][1]&&iK==iSuperGoodtranslist[iTemp][2])
	      iAccepted=0;
	    if(iI==iSuperGoodtranslist[iTemp][0]&&iK==iSuperGoodtranslist[iTemp][1]&&iJ==iSuperGoodtranslist[iTemp][2])
	      iAccepted=0;
	    if(iJ==iSuperGoodtranslist[iTemp][0]&&iI==iSuperGoodtranslist[iTemp][1]&&iK==iSuperGoodtranslist[iTemp][2])
	      iAccepted=0;
	    if(iJ==iSuperGoodtranslist[iTemp][0]&&iK==iSuperGoodtranslist[iTemp][1]&&iI==iSuperGoodtranslist[iTemp][2])
	      iAccepted=0;
	    if(iK==iSuperGoodtranslist[iTemp][0]&&iI==iSuperGoodtranslist[iTemp][1]&&iJ==iSuperGoodtranslist[iTemp][2])
	      iAccepted=0;
	    if(iK==iSuperGoodtranslist[iTemp][0]&&iJ==iSuperGoodtranslist[iTemp][1]&&iI==iSuperGoodtranslist[iTemp][2])
	      iAccepted=0;
	  }
	  if(iAccepted==1){
	    //printf("Transposition, bad, i: %d, j: %d, k: %d\n",iI,iJ,iK);
	    Transposition(iXX,iPermutation,iI,iJ,iK);
	    /* printf("transposition, %d, %d, %d\n",i,iJ,iK);*/
	    (*iN)++;
	    eProposal *= 1.0/(double)(iBadtrans+iBadinvtrans1+iBadinvtrans2);
	  }
	}
      }
      else if(iIntrand(iBadinvtrans1+iBadinvtrans2)<iBadinvtrans1){
	while(iAccepted==0){
	  /* invtransposition1 */
	  iI=iIntrand(iXX+1);
	  iJ=iIntrand(iXX);
	  if(iJ>=iI){
	    iJ++;
	  }
	  else{
	    Swap(&iI,&iJ);
	  }
	  iK=iIntrand(iXX-1);
	  if(iK>=iI){
	    iK++;
	  }
	  if(iK>=iJ){
	    iK++;
	  }
	  if(iK<iI){
	    Swap(&iI,&iK);
	    Swap(&iJ,&iK);
	  }
	  if(iK<iJ){
	    Swap(&iJ,&iK);
	  }	  
	  iAccepted=1;
	  for(iTemp=0;iTemp<iGoodinvtrans1;iTemp++){
	    if(iI==iGoodinvtranslist1[iTemp][0]&&iJ==iGoodinvtranslist1[iTemp][1]&&iK==iGoodinvtranslist1[iTemp][2])
	      iAccepted=0;
	    if(iI==iGoodinvtranslist1[iTemp][0]&&iK==iGoodinvtranslist1[iTemp][1]&&iJ==iGoodinvtranslist1[iTemp][2])
	      iAccepted=0;
	    if(iJ==iGoodinvtranslist1[iTemp][0]&&iI==iGoodinvtranslist1[iTemp][1]&&iK==iGoodinvtranslist1[iTemp][2])
	      iAccepted=0;
	    if(iJ==iGoodinvtranslist1[iTemp][0]&&iK==iGoodinvtranslist1[iTemp][1]&&iI==iGoodinvtranslist1[iTemp][2])
	      iAccepted=0;
	    if(iK==iGoodinvtranslist1[iTemp][0]&&iI==iGoodinvtranslist1[iTemp][1]&&iJ==iGoodinvtranslist1[iTemp][2])
	      iAccepted=0;
	    if(iK==iGoodinvtranslist1[iTemp][0]&&iJ==iGoodinvtranslist1[iTemp][1]&&iI==iGoodinvtranslist1[iTemp][2])
	      iAccepted=0;
	  }
	  for(iTemp=0;iTemp<iSuperGoodinvtrans1;iTemp++){
	    if(iI==iSuperGoodinvtranslist1[iTemp][0]&&iJ==iSuperGoodinvtranslist1[iTemp][1]&&iK==iSuperGoodinvtranslist1[iTemp][2])
	      iAccepted=0;
	    if(iI==iSuperGoodinvtranslist1[iTemp][0]&&iK==iSuperGoodinvtranslist1[iTemp][1]&&iJ==iSuperGoodinvtranslist1[iTemp][2])
	      iAccepted=0;
	    if(iJ==iSuperGoodinvtranslist1[iTemp][0]&&iI==iSuperGoodinvtranslist1[iTemp][1]&&iK==iSuperGoodinvtranslist1[iTemp][2])
	      iAccepted=0;
	    if(iJ==iSuperGoodinvtranslist1[iTemp][0]&&iK==iSuperGoodinvtranslist1[iTemp][1]&&iI==iSuperGoodinvtranslist1[iTemp][2])
	      iAccepted=0;
	    if(iK==iSuperGoodinvtranslist1[iTemp][0]&&iI==iSuperGoodinvtranslist1[iTemp][1]&&iJ==iSuperGoodinvtranslist1[iTemp][2])
	      iAccepted=0;
	    if(iK==iSuperGoodinvtranslist1[iTemp][0]&&iJ==iSuperGoodinvtranslist1[iTemp][1]&&iI==iSuperGoodinvtranslist1[iTemp][2])
	      iAccepted=0;
	  }
	  if(iAccepted==1){
	    //printf("Invtransposition1, bad, i: %d, j: %d, k: %d\n",iI,iJ,iK);
	    Invtransposition1(iXX,iPermutation,iI,iJ,iK);
	    /* printf("invtransposition1, %d, %d, %d\n",i,iJ,iK);*/
	    (*iN)++;
	    eProposal *= 1.0/(double)(iBadtrans+iBadinvtrans1+iBadinvtrans2);
	  }
	}
      }
      else{
	iAccepted=1;
	iI=iIntrand(iXX+1);
	iJ=iIntrand(iXX);
	if(iJ>=iI){
	  iJ++;
	}
	else{
	  Swap(&iI,&iJ);
	}
	iK=iIntrand(iXX-1);
	if(iK>=iI){
	  iK++;
	}
	if(iK>=iJ){
	  iK++;
	}
	if(iK<iI){
	  Swap(&iI,&iK);
	  Swap(&iJ,&iK);
	}
	if(iK<iJ){
	  Swap(&iJ,&iK);
	}	  	
	for(iTemp=0;iTemp<iGoodinvtrans2;iTemp++){
	  if(iI==iGoodinvtranslist2[iTemp][0]&&iJ==iGoodinvtranslist2[iTemp][1]&&iK==iGoodinvtranslist2[iTemp][2])
	    iAccepted=0;
	  if(iI==iGoodinvtranslist2[iTemp][0]&&iK==iGoodinvtranslist2[iTemp][1]&&iJ==iGoodinvtranslist2[iTemp][2])
	    iAccepted=0;
	  if(iJ==iGoodinvtranslist2[iTemp][0]&&iI==iGoodinvtranslist2[iTemp][1]&&iK==iGoodinvtranslist2[iTemp][2])
	    iAccepted=0;
	  if(iJ==iGoodinvtranslist2[iTemp][0]&&iK==iGoodinvtranslist2[iTemp][1]&&iI==iGoodinvtranslist2[iTemp][2])
	    iAccepted=0;
	  if(iK==iGoodinvtranslist2[iTemp][0]&&iI==iGoodinvtranslist2[iTemp][1]&&iJ==iGoodinvtranslist2[iTemp][2])
	    iAccepted=0;
	  if(iK==iGoodinvtranslist2[iTemp][0]&&iJ==iGoodinvtranslist2[iTemp][1]&&iI==iGoodinvtranslist2[iTemp][2])
	    iAccepted=0;
	}
	for(iTemp=0;iTemp<iSuperGoodinvtrans2;iTemp++){
	  if(iI==iSuperGoodinvtranslist2[iTemp][0]&&iJ==iSuperGoodinvtranslist2[iTemp][1]&&iK==iSuperGoodinvtranslist2[iTemp][2])
	    iAccepted=0;
	  if(iI==iSuperGoodinvtranslist2[iTemp][0]&&iK==iSuperGoodinvtranslist2[iTemp][1]&&iJ==iSuperGoodinvtranslist2[iTemp][2])
	    iAccepted=0;
	  if(iJ==iSuperGoodinvtranslist2[iTemp][0]&&iI==iSuperGoodinvtranslist2[iTemp][1]&&iK==iSuperGoodinvtranslist2[iTemp][2])
	    iAccepted=0;
	  if(iJ==iSuperGoodinvtranslist2[iTemp][0]&&iK==iSuperGoodinvtranslist2[iTemp][1]&&iI==iSuperGoodinvtranslist2[iTemp][2])
	    iAccepted=0;
	  if(iK==iSuperGoodinvtranslist2[iTemp][0]&&iI==iSuperGoodinvtranslist2[iTemp][1]&&iJ==iSuperGoodinvtranslist2[iTemp][2])
	    iAccepted=0;
	  if(iK==iSuperGoodinvtranslist2[iTemp][0]&&iJ==iSuperGoodinvtranslist2[iTemp][1]&&iI==iSuperGoodinvtranslist2[iTemp][2])
	    iAccepted=0;
	}
	if(iAccepted==1){
	  //printf("Invtransposition2, bad, i: %d, j: %d, k: %d\n",iI,iJ,iK);
	  Invtransposition2(iXX,iPermutation,iI,iJ,iK);
	  /*		  printf("invtransposition2, %d, %d, %d\n",i,iJ,iK);*/
	  (*iN)++;
	  eProposal *= 1.0/(double)(iBadtrans+iBadinvtrans1+iBadinvtrans2);
	}
      }
      
      /**********************************************************************************************/
  }

  return(eProposal);
}

void Reversion(int iXX,
//++pac	       int iPermutation[2 * iXX + 2],
	       int iPermutation[2 * XX + 2],
	       int iI,
	       int iJ){

//++pac  int iK,iTempperm[2 * iXX + 2];
  int iK,iTempperm[2 * XX + 2];

  for(iK = 2 * iI + 1; iK < 2 * iJ + 1; iK++){
    iTempperm[iK] = iPermutation[2 * iJ + 2 * iI + 1 - iK];
  }
  for(iK = 2 * iI + 1; iK < 2 * iJ + 1; iK++){
    iPermutation[iK]=iTempperm[iK];
  }
}

void Transposition(int iXX,
//++pac 		   int iPermutation[2 * iXX + 2],
		   int iPermutation[2 * XX + 2],
		   int iI,
		   int iJ,
		   int iK){

//++pac  int iTemp, iTempperm[2 * iXX + 2];
 int iTemp, iTempperm[2 * XX + 2];

  for(iTemp = 2 * iI + 1; iTemp < 2 * iJ + 1; iTemp++){
    iTempperm[2 * iK + iTemp - 2 * iJ] = iPermutation[iTemp];
  }
  for(iTemp = 2 * iJ + 1; iTemp < 2 * iK + 1; iTemp++){
    iTempperm[2 * iI + iTemp - 2 * iJ] = iPermutation[iTemp];
  }
  for(iTemp = 2 * iI + 1; iTemp < 2 * iK + 1; iTemp++){
    iPermutation[iTemp] = iTempperm[iTemp];
  }

}


void Invtransposition1(int iXX,
//++pac 		       int iPermutation[2 * iXX + 2],
		       int iPermutation[2 * XX + 2],
		       int iI,
		       int iJ,
		       int iK){

//++pac   int iTemp, iTempperm[2 * iXX + 2];
  int iTemp, iTempperm[2 * XX + 2];

  for(iTemp = 2 * iI + 1; iTemp < 2 * iJ + 1; iTemp++){
    iTempperm[2 * iK + iTemp - 2 * iJ] = iPermutation[2 * iJ + 2 * iI + 1 - iTemp];
  }
  for(iTemp = 2 * iJ + 1; iTemp < 2 * iK + 1; iTemp++){
    iTempperm[2 * iI + iTemp - 2 * iJ] = iPermutation[iTemp];
  }
  for(iTemp = 2 * iI + 1; iTemp < 2 * iK + 1; iTemp++){
    iPermutation[iTemp] = iTempperm[iTemp];
  }

}

void Invtransposition2(int iXX,
//++pac 		       int iPermutation[2 * iXX + 2],
		       int iPermutation[2 * XX + 2],
		       int iI,
		       int iJ,
		       int iK){

//++pac   int iTemp, iTempperm[2 * iXX + 2];
   int iTemp, iTempperm[2 * XX + 2];
	
  for(iTemp = 2 * iI + 1; iTemp < 2 * iJ + 1; iTemp++){
    iTempperm[2 * iK + iTemp - 2 * iJ] = iPermutation[iTemp];
  }
  for(iTemp = 2 * iJ + 1; iTemp < 2 * iK + 1; iTemp++){
    iTempperm[2 * iI + iTemp - 2 * iJ] = iPermutation[2 * iK + 2 * iJ + 1 - iTemp];
  }
  for(iTemp = 2 * iI + 1; iTemp < 2 * iK + 1; iTemp++){
    iPermutation[iTemp] = iTempperm[iTemp];
  }
}



int iIntrand(int iN){

  double eZ;

//++pac
#ifdef _PLAN9
  eZ = (double)rand() * (double)iN / (double)RAND_MAX;
#else
  eZ = (double)random() * (double)iN / (double)RAND_MAX;
#endif
  if(eZ >= iN)
    eZ = iN - 1;
  if(eZ < 0)
    eZ = 0;
  return((int)floor(eZ));
}

void Swap(int *iI, int *iJ){

  int iK;

  iK = *iI;
  *iI = *iJ;
  *iJ = iK;
}

int iTest(char *c1,
	  char *c2){

  int iI,iJ;

  iI = 0;
  iJ = 1;
  while(c1[iI] != '\0' && c2[iI] != '\0'){
    if(c1[iI] != c2[iI]){
      iJ = 0;
    }
    iI++;
  }
    if(c1[iI] != c2[iI]){
      iJ = 0;
    }

    return(iJ);

}
